package hstar.creole.parser

/**
 * Developed with pleasure :)<br>
 * User: HoD<br>
 * Date: 02.10.2010<br>
 * Time: 20:01:06<br>
 */

class Cursor(maxIndex:Int) {
  private var index:Int = 0
  
  def currentIndex = index
  
  def incCursorIndex() {
    incCursorIndexBy(1)
  }
  
  def hasNext = index<maxIndex
  
  val view = new CursorView(this)
  
  def decCursorIndex() {
    incCursorIndexBy(-1)
  }
  
  def incCursorIndexBy(diff:Int) {
    index += diff
  }
  
}

class CursorView(cursor:Cursor) {
  def currentIndex = cursor.currentIndex
}